tree-optimization/116573 - .SELECT_VL for SLP
[official-gcc.git] / contrib / gcc_update
blob417e0483b3f31ef0fcf2d952eae81692654568f9
1 #! /bin/sh
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009,
8 # 2010, 2011, 2012, 2013, 2014, 2015, 2017 Free Software Foundation
9 # Originally by Gerald Pfeifer <gerald@pfeifer.com>, August 1998.
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License. A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
34 # Examples:
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
51 ######## Anything below shouldn't be changed by regular users.
53 # Arrange for the value of $0 to be available for functions
54 self=$0
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60 if [ -z "$silent" ]; then
61 echo "$@"
65 # This function prints a list of all generated files, along with their
66 # dependencies. Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69 sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 fixincludes/fixincl.x: fixincludes/inclhack.def fixincludes/fixincl.tpl
74 # intl library
75 intl/plural.c: intl/plural.y
76 intl/plural-config.h: intl/plural.y
77 intl/configure: intl/configure.ac intl/aclocal.m4
78 intl/config.h.in: intl/configure.ac intl/aclocal.m4
79 # Now, proceed to gcc automatically generated files
80 gcc/configure: gcc/configure.ac
81 gcc/cstamp-h.in: gcc/configure.ac
82 gcc/config.in: gcc/cstamp-h.in
83 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
84 gcc/config/aarch64/aarch64-tune.md: gcc/config/aarch64/aarch64-cores.def gcc/config/aarch64/gentune.sh
85 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
86 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
87 gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
88 gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
89 gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
90 gcc/config/loongarch/loongarch-str.h: gcc/config/loongarch/genopts/genstr.sh gcc/config/loongarch/genopts/loongarch-strings
91 gcc/config/loongarch/loongarch.opt: gcc/config/loongarch/genopts/genstr.sh gcc/config/loongarch/genopts/loongarch.opt.in
92 gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
93 gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
94 gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
95 gcc/config/rs6000/fusion.md: gcc/config/rs6000/genfusion.pl
96 # And then, language-specific files
97 gcc/cp/cfns.h: gcc/cp/cfns.gperf
98 gcc/cp/std-name-hint.h: gcc/cp/std-name-hint.gperf
99 gcc/cp/std-name-hint.gperf: gcc/cp/cxxapi-data.csv
100 gcc/m2/configure: gcc/m2/configure.ac
101 gcc/m2/gm2config.h.in: gcc/m2/configure.ac
102 gcc/m2/gm2-libs/config-host: gcc/m2/gm2-libs/config-host.in
103 # testsuite
104 # Without this, _Pragma3.c can have a false negative.
105 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
106 # Similarly, without this, you will see:
107 # direct2s.c:35: warning: current file is older than direct2.c
108 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
109 # lto-plugin
110 lto-plugin/aclocal.m4: lto-plugin/configure.ac
111 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
112 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
113 # tools
114 c++tools/configure: c++tools/configure.ac
115 c++tools/config.h.in: c++tools/configure.ac
116 # And libraries, at last
117 libbanshee/configure: libbanshee/configure.ac
118 libmudflap/configure: libmudflap/configure.ac
119 libobjc/configure: libobjc/configure.ac
120 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
121 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
122 zlib/configure: zlib/configure.ac zlib/aclocal.m4
123 fastjar/aclocal.m4: fastjar/configure.ac
124 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
125 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
126 boehm-gc/aclocal.m4: boehm-gc/configure.ac
127 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
128 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
129 libada/configure: libada/configure.ac
130 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
131 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
132 libffi/configure: libffi/configure.ac libffi/aclocal.m4
133 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
134 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
135 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
136 libgm2/Makefile.in: libgm2/Makefile.am libgm2/configure.ac libgm2/aclocal.m4
137 libgm2/aclocal.m4: libgm2/configure.ac
138 libgm2/libm2cor/Makefile.in: libgm2/libm2cor/Makefile.am
139 libgm2/libm2pim/Makefile.in: libgm2/libm2pim/Makefile.am
140 libgm2/libm2iso/Makefile.in: libgm2/libm2iso/Makefile.am
141 libgm2/libm2log/Makefile.in: libgm2/libm2log/Makefile.am
142 libgm2/libm2min/Makefile.in: libgm2/libm2min/Makefile.am
143 libquadmath/configure: libquadmath/configure.ac libquadmath/aclocal.m4
144 libquadmath/aclocal.m4: libquadmath/configure.ac libquadmath/acinclude.m4
145 libquadmath/Makefile.in: libquadmath/Makefile.am libquadmath/configure.ac libgfortran/aclocal.m4
146 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
147 libcody/configure: libcody/configure.ac libcody/config.m4
148 libcpp/aclocal.m4: libcpp/configure.ac
149 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
150 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
151 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
152 libgomp/Makefile.am: libgomp/plugin/Makefrag.am
153 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
154 libgomp/testsuite/Makefile.in: libgomp/testsuite/Makefile.am libgomp/aclocal.m4
155 libgomp/configure.ac: libgomp/plugin/configfrag.ac
156 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
157 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
158 libgrust/Makefile.in: libgrust/Makefile.am libgrust/aclocal.m4
159 libgrust/aclocal.m4: libgrust/configure.ac
160 libgrust/configure: libgrust/configure.ac libgrust/aclocal.m4
161 libgrust/libformat_parser/Makefile.in: libgrust/libformat_parser/Makefile.am libgrust/aclocal.m4
162 libgrust/libproc_macro_internal/Makefile.in: libgrust/libproc_macro_internal/Makefile.am libgrust/aclocal.m4
163 libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
164 libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
165 libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
166 libitm/configure: libitm/configure.ac libitm/aclocal.m4
167 libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
168 libatomic/aclocal.m4: libatomic/configure.ac libatomic/acinclude.m4
169 libatomic/Makefile.in: libatomic/Makefile.am libatomic/aclocal.m4
170 libatomic/testsuite/Makefile.in: libatomic/testsuite/Makefile.am libatomic/aclocal.m4
171 libatomic/configure: libatomic/configure.ac libatomic/aclocal.m4
172 libatomic/auto-config.h.in: libatomic/configure.ac libatomic/aclocal.m4
173 libsanitizer/aclocal.m4: libsanitizer/configure.ac libsanitizer/acinclude.m4
174 libsanitizer/Makefile.in: libsanitizer/Makefile.am libsanitizer/aclocal.m4
175 libsanitizer/configure: libsanitizer/configure.ac libsanitizer/aclocal.m4
176 libsanitizer/asan/Makefile.in: libsanitizer/asan/Makefile.am libsanitizer/aclocal.m4
177 libsanitizer/interception/Makefile.in: libsanitizer/interception/Makefile.am libsanitizer/aclocal.m4
178 libsanitizer/sanitizer_common/Makefile.in: libsanitizer/sanitizer_common/Makefile.am libsanitizer/aclocal.m4
179 libvtv/aclocal.m4: libvtv/configure.ac libvtv/acinclude.m4
180 libvtv/Makefile.in: libvtv/Makefile.am libvtv/aclocal.m4
181 libvtv/configure: libvtv/configure.ac libvtv/aclocal.m4
182 libbacktrace/aclocal.m4: libbacktrace/configure.ac
183 libbacktrace/Makefile.in: libbacktrace/Makefile.am libbacktrace/aclocal.m4
184 libbacktrace/configure: libbacktrace/configure.ac libbacktrace/aclocal.m4
185 libbacktrace/config.h.in: libbacktrace/configure.ac libbacktrace/aclocal.m4
186 libphobos/Makefile.in: libphobos/Makefile.am libphobos/configure.ac libphobos/aclocal.m4
187 libphobos/aclocal.m4: libphobos/configure.ac libphobos/acinclude.m4
188 libphobos/config.h.in: libphobos/configure.ac libphobos/aclocal.m4
189 libphobos/configure: libphobos/configure.ac libphobos/aclocal.m4
190 libphobos/src/Makefile.in: libphobos/src/Makefile.am libphobos/aclocal.m4
191 libphobos/testsuite/Makefile.in: libphobos/testsuite/Makefile.am libphobos/aclocal.m4
192 libstdc++-v3/aclocal.m4: libstdc++-v3/configure.ac libstdc++-v3/acinclude.m4
193 libstdc++-v3/Makefile.in: libstdc++-v3/Makefile.am libstdc++-v3/aclocal.m4
194 libstdc++-v3/configure: libstdc++-v3/configure.ac libstdc++-v3/acinclude.m4
195 libstdc++-v3/include/bits/version.h: libstdc++-v3/include/bits/version.def libstdc++-v3/include/bits/version.tpl
196 libcc1/aclocal.m4: libcc1/configure.ac
197 libcc1/Makefile.in: libcc1/Makefile.am libcc1/configure.ac libcc1/aclocal.m4
198 libcc1/configure: libcc1/configure.ac
199 # Top level
200 Makefile.in: Makefile.tpl Makefile.def
201 configure: configure.ac config/acx.m4
206 # This function touches generated files such that the ``end'' user does
207 # not have to rebuild them.
208 touch_files () {
209 rm -f Makefile.$$
210 echo 'all: \' > Makefile.$$
211 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
212 echo '; @true' >> Makefile.$$
213 files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
214 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
215 echo ':' >> Makefile.$$
216 echo ' @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
217 echo ' echo Touching $@...; \' >> Makefile.$$
218 chat ' echo Touching $@... 1>&2; \' >> Makefile.$$
219 echo ' touch $@' >> Makefile.$$
220 files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
222 # We would have to explicitly shut off the "Entering... Leaving..."
223 # messages through "--no-print-directory" to handle the case when
224 # we were called from a recursive invocation (i.e. "$(MAKE)" in a
225 # Makefile, not just make). Passing only "-s" doesn't help then,
226 # because make has helpfully added "-w" to MAKEFLAGS automatically.
227 # Unfortunately we do not require GNU make other than for building
228 # and testing, so let's just grep known text explicitly echoed by
229 # the rule.
230 while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
231 sleep 1
232 done 2>&1
233 rm -f Makefile.$$
237 # Whenever we update the tree or install a patch, we may be modifying
238 # this script. By re-execing it, we ensure that the appropriate
239 # dependencies and rules will be used.
240 touch_files_reexec () {
241 chat "Adjusting file timestamps"
242 exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
245 # This functions applies a patch to an existing tree.
246 apply_patch () {
247 if [ -f "$1" ]; then
248 echo "Applying patch file $1"
249 case $1 in
250 *gz)
251 gzip -d -c "$1" | patch -p1 ;;
252 *bz2)
253 bzip2 -d -c "$1" | patch -p1 ;;
255 patch -p1 < "$1";;
256 esac
258 touch_files_reexec
261 # Check whether this indeed looks like a local tree.
262 if [ ! -f gcc/reload.cc ]; then
263 echo "This does not seem to be a GCC tree!"
264 exit
267 case "$1" in
268 --silent)
269 silent=t
270 shift
272 esac
274 case "$1" in
275 # First of all, check whether we are going to process a patch.
276 --patch)
277 if test "$#" != 2; then
278 echo "$1" expects only one argument >&2
279 exit 1
281 apply_patch "${2}"
282 exit $?
285 --touch)
286 if test "$#" != 1; then
287 echo "$1" does not expect any argument >&2
288 exit 1
290 touch_files
291 exit $?
294 --list)
295 if test "$#" != 1; then
296 echo "$1" does not expect any argument >&2
297 exit 1
299 files_and_dependencies | sed 's/ /: /'
300 exit $?
303 --help)
304 sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
308 }' \
309 -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
310 exit $?
313 esac
315 # Check for known version control systems.
316 if [ -d .git ] || [ -f .git ]; then
317 GCC_GIT=${GCC_GIT-${GIT-git}}
318 vcs_type="git"
319 elif [ -d .hg ]; then
320 GCC_HG=${GCC_HG-${HG-hg}}
321 vcs_type="hg"
322 elif [ -d .svn ]; then
323 GCC_SVN=${GCC_SVN-${SVN-svn}}
324 vcs_type="svn"
325 else
326 echo "This does not seem to be a GCC GIT/HG/SVN tree!"
327 exit
330 # Check command-line options
331 if [ x"${1}"x = x"--nostdflags"x ]; then
332 shift
333 else
334 set -- $UPDATE_OPTIONS ${1+"$@"}
337 case $vcs_type in
338 git)
339 chat "Updating GIT tree"
341 $GCC_GIT diff --quiet --exit-code HEAD
342 if [ $? -ne 0 ]; then
343 echo "Attempting to update a dirty git tree!" >&2
344 echo "Commit or stash your changes first and retry." >&2
345 exit 1
348 $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
349 if [ $? -ne 0 ]; then
350 (touch_files_reexec)
351 echo "git pull of full tree failed." >&2
352 exit 1
355 # Open-coded version of "git gcc-descr" from contrib/gcc-git-customization.sh
356 revision=`$GCC_GIT log -n1 --pretty=tformat:%h`
357 r=`$GCC_GIT describe --all --match 'basepoints/gcc-[0-9]*' HEAD \
358 | sed -n 's,^\(tags/\)\?basepoints/gcc-\([0-9]\+\)-\([0-9]\+\)-g[0-9a-f]*$,r\2-\3,p;s,^\(tags/\)\?basepoints/gcc-\([0-9]\+\)$,r\2-0,p'`;
359 if test -n "$r"; then
360 o=`$GCC_GIT config --get gcc-config.upstream`;
361 rr=`echo $r | sed -n 's,^r\([0-9]\+\)-[0-9]\+\(-g[0-9a-f]\+\)\?$,\1,p'`;
362 if $GCC_GIT rev-parse --verify --quiet ${o:-origin}/releases/gcc-$rr >/dev/null; then
363 m=releases/gcc-$rr;
364 else
365 m=master;
367 if $GCC_GIT merge-base --is-ancestor HEAD ${o:-origin}/$m; then
368 revision=${r}-g${revision};
371 branch=`$GCC_GIT name-rev --name-only HEAD || :`
375 chat "Updating HG tree"
377 # Add -q so untracked files aren't listed.
378 if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
379 echo "Attempting to update a dirty hg tree!" >&2
380 echo "Commit or revert your changes first and retry." >&2
381 exit 1
384 # Check for mq extension. mq patches must be popped so tip has
385 # been converted from the SVN tree.
386 if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
387 # FIXME: Perhaps pop queue instead? We could do that since we
388 # know the tree is clean.
389 echo "Attempting to update hg tree with mq patches applied!" >&2
390 echo "Pop your patches first and retry." >&2
391 exit 1
394 # Update tree, but make sure to only pull the default branch.
395 # Otherwise all branches in the upstream repo are added, even if
396 # only a single one has been cloned.
397 $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
398 if [ $? -ne 0 ]; then
399 (touch_files_reexec)
400 echo "hg pull of full tree failed." >&2
401 exit 1
404 # Update tree. Needs to be done separately from pull so
405 # gcc_update -rREV works.
406 $GCC_HG update ${silent+-q} ${1+"$@"}
407 if [ $? -ne 0 ]; then
408 (touch_files_reexec)
409 echo "hg update of full tree failed." >&2
410 exit 1
413 # Extract SVN revision corresponding to parents, as stored by
414 # hg convert. Before hg 1.4.3, there's no template keyword
415 # corresponding to the extra: tag, so need to use hg log --debug
416 # to extract the info.
417 parents=`$GCC_HG parents --template '{rev}'`
418 convert_revision=`$GCC_HG log --debug -r$parents | \
419 sed -ne "/^extra:.*convert_revision=svn:/ {
420 s%^[^/]*/%%
423 revision=`echo $convert_revision | sed -e 's/.*@//'`
424 branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
427 svn)
428 chat "Updating SVN tree"
430 $GCC_SVN ${silent+-q} --non-interactive update ${1+"$@"}
431 if [ $? -ne 0 ]; then
432 (touch_files_reexec)
433 echo "SVN update of full tree failed." >&2
434 exit 1
437 revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
438 branch=`$GCC_SVN info | sed -ne "/^URL:/ {
439 s,.*/trunk,trunk,
440 s,.*/branches/,,
441 s,.*/tags/,,
445 esac
447 rm -f LAST_UPDATED gcc/REVISION
449 date
450 echo "`TZ=UTC date` (revision $revision)"
451 } > LAST_UPDATED
452 echo "[$branch $revision]" > gcc/REVISION
454 touch_files_reexec